package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.http.Context
import view.EducationYear
import view.toEntity
import view.toView

class EducationYearController(private val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(EducationYear::class.java)
            database.educationYearQueries.insertEducationYear(bodyAsClass.toEntity())
            val executeAsOne =
                database.educationYearQueries.oneEducationYear(bodyAsClass.endDate, bodyAsClass.school).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }
    
    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(EducationYear::class.java)
        database.educationYearQueries.deleteEducationYear(bodyAsClass.endDate, bodyAsClass.school)
    }
}
