package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.*

class InterestController(val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(Interest::class.java)
            database.interestsQueries.insertInterest(bodyAsClass.toEntity())
            val executeAsOne =
                database.interestsQueries.oneInterest(bodyAsClass.theme).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(DeleteInterest::class.java)
        database.interestsQueries.deleteInterest(bodyAsClass.theme)
    }
}
