package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.*

class JobController(val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(Job::class.java)
            database.jobsQueries.insertJob(bodyAsClass.toEntity())
            val executeAsOne =
                database.jobsQueries.oneJob(bodyAsClass.start, bodyAsClass.end, bodyAsClass.company).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(DeleteJob::class.java)
        database.jobsQueries.deleteJob(bodyAsClass.start, bodyAsClass.end, bodyAsClass.company)
    }
}
