package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.*

class LanguageController(val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(Language::class.java)
            database.languagesQueries.insertLang(bodyAsClass.toEntity())
            val executeAsOne =
                database.languagesQueries.oneLang(bodyAsClass.lang).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(DeleteLanguage::class.java)
        database.languagesQueries.deleteLang(bodyAsClass.lang)
    }
}
