package controller

import fr.louveauAmine.cvApi.dao.*
import io.javalin.http.Context
import view.*

class MeController(private val database: CVApiDB) {
    fun getMe(ctx: Context) {

        ctx.json(
            Me(
              profile = database.profileQueries.profiles().executeAsOne().toView(),
              interests = database.interestsQueries.interests().executeAsList().map { it.toView() },
              jobs = database.jobsQueries.jobs().executeAsList().map { it.toView() },
              sideProjects = database.sideProjectsQueries.sideProjects().executeAsList().map { it.toView() }.groupBy { it.category },
              educationYears = database.educationYearQueries.educationYears().executeAsList().map { it.toView() },
              languages = database.languagesQueries.langs().executeAsList().map { it.toView() },
              tags = database.tagsQueries.tags().executeAsList().map { it.toView() }
            )
        )
    }
}

