package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.*

class ProfileController(val database: CVApiDB) {

    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(Profile::class.java)
            database.profileQueries.insertProfile(bodyAsClass.toEntity())
            val executeAsOne =
                database.profileQueries.oneProfile(bodyAsClass.name).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun update(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(UpdateProfile::class.java)
        val existing = database.profileQueries.oneProfile(bodyAsClass.name).executeAsOne()
        database.profileQueries.updateProfile(
            bodyAsClass.newName ?: existing.name,
            bodyAsClass.title ?: existing.title,
            bodyAsClass.quote ?: existing.quote,
            bodyAsClass.picture ?: existing.picture,
            bodyAsClass.email ?: existing.email,
            bodyAsClass.phone ?: existing.phone,
            bodyAsClass.linkedin ?: existing.linkedin,
            bodyAsClass.source ?: existing.source,
            bodyAsClass.name
        )
        val executeAsOne =
            database.profileQueries.oneProfile(bodyAsClass.newName ?: existing.name).executeAsOne()
        ctx.json(executeAsOne.toView())
    }

}
