package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.DeleteSideProject
import view.SideProject
import view.toEntity
import view.toView

class SideProjectController(val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(SideProject::class.java)
            database.sideProjectsQueries.insertSideProject(bodyAsClass.toEntity())
            val executeAsOne =
                database.sideProjectsQueries.oneSideProject(bodyAsClass.description, bodyAsClass.category).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(DeleteSideProject::class.java)
        database.sideProjectsQueries.deleteSideProject(bodyAsClass.description, bodyAsClass.category)
    }
}
